;
; $Header: D:/ext2-os2/rcs/devhelp2.asm,v 5.0 1995/12/29 23:17:55 Willm Exp Willm $
;

; Linux ext2 file system driver for OS/2 2.x and WARP - Allows OS/2 to
; access your Linux ext2fs partitions as normal drive letters.
; OS/2 implementation : Copyright (C) 1995  Matthieu WILLM
;
; This program is free software; you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation; either version 2 of the License, or
; (at your option) any later version.
;
; This program is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.
;
; You should have received a copy of the GNU General Public License
; along with this program; if not, write to the Free Software
; Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.


;
; These are *LARGE MEMORY MODEL* DevHelp C bindings
;
        .286p
        .model large

        INCL_DOSERRORS  EQU     1
        include os2.inc                         ; From the "Developer Connection Device Driver Kit" version 2.0
        include devhlp.inc                      ; From the "Developer Connection Device Driver Kit" version 2.0
        include sas.inc                         ; From the "Developer Connection Device Driver Kit" version 2.0

        public _Device_Help

        .data

extrn   TCB_USER_ID : abs                        ; Offset to uid field in TCB
extrn   SAS_SEL     : abs                        ; System Anchor Segment selector


        sas_ptr      dd (?)

.386p
EXT2_FIXED_DATA SEGMENT WORD USE16 PUBLIC 'FIXED_DATA'
        _Device_Help dd (?)                     ; Device helper entry point in the NON SWAPPABLE data segment
EXT2_FIXED_DATA ends
.286p


        .code
        .386p

;
; int Beep(int frequency, int duration);
;
public _Beep
_Beep proc far
        push bp
        mov  bp, sp
        push ds
        push fs
        mov ax, DGROUP
        mov ds, ax
        ASSUME DS: DGROUP
        mov ax, EXT2_FIXED_DATA          ;
        mov fs, ax                       ; Non swappable data segment where Device_Help is stored.
        ASSUME FS : EXT2_FIXED_DATA      ;

        mov bx, [bp + 6]                 ; frequency
        mov cx, [bp + 8]                 ; duration
        mov dl, DevHlp_Beep
        call [_Device_Help]

        pop fs
        pop ds
        leave
        retf
_Beep endp

;
;int VirtToLin(void *virt, unsigned long *plin)
;
public _VirtToLin
_VirtToLin proc far
        push bp
        mov  bp, sp
        push ds
        push es
        push fs
        push si
        push di
        mov ax, DGROUP
        mov ds, ax
        mov es, ax
        ASSUME DS: DGROUP, ES : DGROUP
        mov ax, EXT2_FIXED_DATA          ;
        mov fs, ax                       ; Non swappable data segment where Device_Help is stored.
        ASSUME FS : EXT2_FIXED_DATA      ;

        mov dl, DevHlp_VirtToLin
        xor eax, eax
        mov esi, eax
        mov ax, [bp + 8]                ; (__segment) virt
        mov si, [bp + 6]                ; OFFSETOF(virt)
        call  [_Device_Help]
        jc    VirtToLin_error                ; if error, EAX = error code
        les di, [bp + 10]                ; plin
        mov dword ptr es:[di], eax        ; *plin
        mov ax, NO_ERROR

VirtToLin_error:
        pop di
        pop si
        pop fs
        pop es
        pop ds
        leave
        retf
_VirtToLin endp

;
; int VMLock(
;            unsigned long flags,                [bp + 6]
;            unsigned long lin,                        [bp + 10]
;            unsigned long length,                [bp + 14]
;            void          *pPageList,                [bp + 18]
;            void            *pLockHandle,        [bp + 22]
;             unsigned long *pPageListCount        [bp + 26]
;           );
;
public _VMLock
_VMLock proc far
        push bp
        mov  bp, sp
        push ds
        push es
        push fs
        push si
        push di
        mov ax, DGROUP
        mov ds, ax
        mov es, ax
        ASSUME DS : DGROUP, ES : DGROUP
        mov ax, EXT2_FIXED_DATA          ;
        mov fs, ax                       ; Non swappable data segment where Device_Help is stored.
        ASSUME FS : EXT2_FIXED_DATA      ;


        mov ebx, [bp + 10]        ; lin
        mov ecx, [bp + 14]        ; length
        mov edi, [bp + 18]        ; pPageList
        mov esi, [bp + 22]        ; pLockHandle
        mov eax, [bp + 6]        ; flags
        mov dl, DevHlp_VMLock
        call [_Device_Help]
        jc    VMLock_error        ; if error, EAX = error code
        les di, [bp + 26]        ; pPageListCount
        mov es:[di], eax        ;*pPageListCount
        mov ax, NO_ERROR
VMLock_error:
        pop di
        pop si
        pop fs
        pop es
        pop ds
        leave
        retf
_VMLock endp

;
; int VMUnlock(void *pLockHandle);
;
public _VMUnlock
_VMUnlock proc far
        push bp
        mov  bp, sp
        push ds
        push es
        push fs
        push si
        push di
        mov ax, DGROUP
        mov ds, ax
        mov es, ax
        ASSUME DS : DGROUP, ES : DGROUP
        mov ax, EXT2_FIXED_DATA          ;
        mov fs, ax                       ; Non swappable data segment where Device_Help is stored.
        ASSUME FS : EXT2_FIXED_DATA      ;


        mov esi, [bp + 6]        ; pLockHandle
        mov dl, DevHlp_VMUnlock
        call [_Device_Help]
        jc    VMUnlock_error        ; if error, EAX = error code
        mov ax, NO_ERROR
VMUnlock_error:
        pop di
        pop si
        pop fs
        pop es
        pop ds
        leave
        retf
_VMUnlock endp



;
;int VirtToPhys(unsigned long virt, unsigned long *phys)
;
public _VirtToPhys
_VirtToPhys proc far
        push bp
        mov  bp, sp
        push ds
        push es
        push fs
        push si
        push di
        mov ax, DGROUP
        mov ds, ax
        mov es, ax
        ASSUME DS : DGROUP, ES : DGROUP
        mov ax, EXT2_FIXED_DATA          ;
        mov fs, ax                       ; Non swappable data segment where Device_Help is stored.
        ASSUME FS : EXT2_FIXED_DATA      ;

        lds si, [bp + 6]                ; virt
        mov dl, DevHlp_VirtToPhys
        call  [_Device_Help]
        jc    VirtToPhys_error
        les di, [bp + 10]                ; phys
        mov word ptr es:[di], bx
        mov word ptr es:[di + 2], ax
        mov ax, NO_ERROR
        jmp VirtToPhys_out
VirtToPhys_error:
        mov ax, -1
VirtToPhys_out:
        pop di
        pop si
        pop fs
        pop es
        pop ds
        leave
        retf
_VirtToPhys endp

;
; int FS_DevHelp_VMAlloc(
;                        unsigned long Taille,                /* bp + 6  */
;                        unsigned long PhysAddr,        /* bp + 10 */
;                        unsigned long Flags,           /* bp + 14 */
;                        PUINT32 LinAddr                /* bp + 18 */
;                       );
;
;
public _FS_DevHelp_VMAlloc
_FS_DevHelp_VMAlloc proc far
        push bp
        mov  bp, sp
        push ds
        push es
        push fs
        push di
        mov ax, DGROUP
        mov ds, ax
        ASSUME DS: DGROUP
        mov ax, EXT2_FIXED_DATA          ;
        mov fs, ax                       ; Non swappable data segment where Device_Help is stored.
        ASSUME FS : EXT2_FIXED_DATA      ;

        mov   ecx, dword ptr[bp + 6]                ; Taille
        mov   edi, dword ptr[bp + 10]                ; PhysAddr
        mov   eax, dword ptr[bp + 14]                ; Flags
        mov   dl, DevHlp_VMAlloc
        call  [_Device_Help]
        jc    VMAlloc_error

        les   bx, dword ptr[bp + 18]                ; LinAddr
        mov   es:[bx], eax
        mov   ax, NO_ERROR
        jmp VMAlloc_out
VMAlloc_error:
        mov ax, -1

VMAlloc_out:
        pop di
        pop fs
        pop es
        pop ds
        leave
        retf
_FS_DevHelp_VMAlloc endp

;
; int FS_DevHelp_VMFree(
;                       unsigned long LinAddr        /* bp + 6 */
;                      );
;
public _FS_DevHelp_VMFree
_FS_DevHelp_VMFree proc far
;ARG @@LinAddr:DWORD
        push bp
        mov  bp,sp
        push ds
        push fs
        mov ax, DGROUP
        mov ds, ax
        ASSUME DS: DGROUP
        mov ax, EXT2_FIXED_DATA          ;
        mov fs, ax                       ; Non swappable data segment where Device_Help is stored.
        ASSUME FS : EXT2_FIXED_DATA      ;

    mov   eax, dword ptr[bp + 6]                ; LinAddr
    mov   dl, DevHlp_VMFree
    call  [_Device_Help]
    jc    VMFree_error
    mov   ax, NO_ERROR
    jmp VMFree_out
VMFree_error:
    mov ax, -1

VMFree_out:
        pop fs
        pop ds
        leave
        retf
_FS_DevHelp_VMFree endp

;
; int FS_DevHelp_GetDOSVar(
;                          unsigned char index,        /* bp + 6  */
;                          ppchar value                /* bp + 8  */
;                         );
;
public _FS_DevHelp_GetDOSVar
_FS_DevHelp_GetDOSVar proc far
        push bp
        mov  bp, sp
        push ds
        push es
        push fs
        mov ax, DGROUP
        mov ds, ax
        ASSUME DS: DGROUP
        mov ax, EXT2_FIXED_DATA          ;
        mov fs, ax                       ; Non swappable data segment where Device_Help is stored.
        ASSUME FS : EXT2_FIXED_DATA      ;

        mov al, byte ptr[bp + 6]                    ; index
        mov dl, DevHlp_GetDOSVar
        call [_Device_Help]
        jc GetDOSVar_error
        les di, dword ptr[bp + 8]                  ; value
        mov es:[di], bx
        mov es:[di + 2], ax
        mov ax, NO_ERROR
        jmp GetDOSVar_out

GetDOSVar_error:
        mov ax, -1

GetDOSVar_out:
        pop fs
        pop es
        pop ds
        leave
        retf
_FS_DevHelp_GetDOSVar endp


;
; int ProcBlock(
;                unsigned long  eventid,       /* bp + 6  */
;                long           timeout,       /* bp + 10 */
;                short          interruptible  /* bp + 14 */
;               );
;
public _ProcBlock
_ProcBlock proc far
        push bp
        mov  bp, sp
        push ds
        push es
        push fs
        push di
        mov ax, DGROUP
        mov ds, ax
        ASSUME DS: DGROUP
        mov ax, EXT2_FIXED_DATA          ;
        mov fs, ax                       ; Non swappable data segment where Device_Help is stored.
        ASSUME FS : EXT2_FIXED_DATA      ;

        mov bx, [bp + 6]                 ; eventid_low
        mov ax, [bp + 8]                 ; eventid_high
        mov di, [bp + 12]                ; timeout_high
        mov cx, [bp + 10]                ; timeout_low
        mov dh, [bp + 14]                ; interruptible_flag
        mov dl, DevHlp_ProcBlock
        call [_Device_Help]
        mov ah, 0
        pop di
        pop fs
        pop es
        pop ds
        leave
        retf
_ProcBlock endp


;
; int ProcRun(
;             unsigned longt eventid        /* bp + 6  */
;            );
;
public _ProcRun
_ProcRun proc far
        push bp
        mov  bp, sp
        push ds
        push fs
        mov ax, DGROUP
        mov ds, ax
        ASSUME DS: DGROUP
        mov ax, EXT2_FIXED_DATA          ;
        mov fs, ax                       ; Non swappable data segment where Device_Help is stored.
        ASSUME FS : EXT2_FIXED_DATA      ;

        mov bx, [bp + 6]                 ; eventid_low
        mov ax, [bp + 8]                 ; eventid_high
        mov dl, DevHlp_ProcRun
        call [_Device_Help]
        pop fs
        pop ds
        leave
        retf
_ProcRun endp


;
; unsigned short getuid(void)
;
public _getuid
_getuid proc far
        push bp
        mov  bp, sp
        push ds
        push es
        mov ax, DGROUP
        mov ds, ax
        ASSUME DS: DGROUP


        mov ax, SAS_SEL                        ; System Anchor Segment selector
        mov es, ax
        mov bx, 0                        ; now es:bx points to the SASbase


        mov ax, es:[bx].SAS_flat_sel        ; Flat kernel Data segment
        mov ds, ax                        ; ds now is the FLAT ring 0 selector
        assume ds:nothing
        mov cx, es:[bx].SAS_task_data        ; task section offset in SAS
        add bx, cx                        ; now es:bx points to the task section of SAS

        mov ecx, es:[bx].SAS_task_threadptrs ; FLAT address of address of TCB address array
        mov ecx, [ecx]                             ; FLAT address of TCB address array
        mov ebx, es:[bx].SAS_task_tasknumber ; FLAT address of FLAT address of current TCB
        mov ebx, [ebx]                       ; FLAT address of current TCB number
        mov ebx, [ecx + 4 * ebx]             ; FLAT address of current TCB
        xor eax, eax
        mov ax, word ptr [ebx + TCB_USER_ID] ; user id
        pop es
        pop ds
        leave
        retf
_getuid endp

;
; unsigned short setuid(unsigned short uid);
;
public _setuid
_setuid proc far
        push bp
        mov  bp, sp
        push ds
        push es
        mov ax, DGROUP
        mov ds, ax
        ASSUME DS: DGROUP

        push si
        push di
        mov si, [bp + 6]                ; uid

        mov ax, SAS_SEL                        ; System Anchor Segment selector
        mov es, ax
        mov bx, 0                        ; now es:bx points to the SAS base


        mov ax, es:[bx].SAS_flat_sel        ; Flat kernel Data segment
        mov ds, ax                        ; ds now is the FLAT ring 0 selector
        assume ds:nothing
        mov cx, es:[bx].SAS_task_data        ; task section offset in SAS
        add bx, cx                        ; now es:bx points to the task section of SAS

        mov ecx, es:[bx].SAS_task_threadptrs ; FLAT address of address of TCB address array
        mov ecx, [ecx]                             ; FLAT address of TCB address array
        mov ebx, es:[bx].SAS_task_tasknumber ; FLAT address of FLAT address of current TCB
        mov ebx, [ebx]                       ; FLAT address of current TCB number
        mov ebx, [ecx + 4 * ebx]             ; FLAT address of current TCB
        mov word ptr [ebx + TCB_USER_ID], si ; user id
        pop di
        pop si
        pop es
        pop ds
        leave
        retf
_setuid endp

        end

